#!/usr/bin/perl
#
# create a single ctd from multiple canna format dictionaries.
# Usage:
#  % perl tools/mkdic.pl (dict1) (dict2) (dict3) ... > basic.ctd
#  % (edit basic.ctd)
#  % cat basic.ctd | sort | uniq > $$ ; mv $$ basic.ctd
#  % mkbindic basic.ctd
#
$text++ if ($ARGV[0] eq '-t');

@files = @ARGV;

open(OE, "> error.ctd");

#$badchar1 = '^[\w\s-']+$';
#$badchar2 = '[\{\}\[\]\\\\.\,]';	# don't include (") and (')

LOOP:
foreach $f (@files) {
	chomp($f);

	$no = 0;
	open(IN, "< $f");
	while (<IN>) {
		chomp;
		$no++;
		($yomi, $hinshi, $tango) = split(/\s+/, $_, 3);

		# sanity check
		if (!$yomi || !$hinshi || !$tango ||
		    $hinshi !~ /^#/) {
			print OE "$f:$no:invalid:$_\n";
			next;
		}

		# proper check
		if (length($yomi) > 60) {
			print OE "$f:$no:too_long:$_\n";
			next;
		}
		if ($text) {
			$t{$yomi . ' ' . $hinshi} .= $tango . ' ';
		} else {
			if ($yomi =~ /$badchar1/ || $tango =~ /$badchar1/) {
				print OE "$f:$no:bad_char1:$_\n";
				next;
			}
			if ($yomi =~ /$badchar2/ || $tango =~ /$badchar2/) {
				print OE "$f:$no:bad_char2:$_\n";
				next;
			}
			print "$yomi $hinshi $tango\n";
		}
	}
	close(IN);
}
close(OE);

if ($text) {
	foreach (sort keys %t) {
		@x = split(/\s/);
		print "$x[0] $x[1] $t{$_}\n";
	}
}

# XXX too slow
sub invalid_quote
{
	my ($w) = @_;
	my @y;
	my $n;

        @y = split(/ */, $w);
        $n = grep(/'/, @y);
        return 1 if ($n % 2);
	return 0;
}
